﻿
-- My Garrison is Done --
-- Written by Jaxom of Hellfire --
-- Based on an Idea by Cederra of Hellfire, He helps test my addons and this was his idea. --
-- GNU General Public License version 3 (GPLv3) --

local GarrisonDone = ...

GarrisonDone_Version = GetAddOnMetadata("GarrisonDone", "Version")

    -- DEFAULTS --

local playerName = UnitName("player");
local character = UnitName("player").."-"..GetRealmName();
local playerID = UnitGUID;
local faction = UnitFactionGroup("player")
local self = GarrisonDone;
local toon = character:match("([^-]+)")
local DCF = DEFAULT_CHAT_FRAME;
local MISSION_PAGE_FRAME;



local waitTable = {};
local waitFrame = nil;

        -- Timer Function --
function GarrisonDone_Wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

    -- ON LOAD --

function GarrisonDone_OnLoad(self)

    
    -- START --
        -- Assign Tabs for second Tab to show alts --
        PanelTemplates_SetNumTabs(GarrisonDoneFrame, 3);  -- 3 = frames total. Options moved to a button --
        PanelTemplates_SetTab(GarrisonDoneFrame, 1);      -- 1 = tab 1 selected. --
        GarrisonDoneEditFrame:Show();
        MGD_FollowersButton:Show();
        GarrisonDoneBuildFrame:Hide();
        GarrisonDoneBuildScrollFrame:Hide();
        GarrisonDoneAltsFrame:Hide();
        GarrisonDoneAltsScrollFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
        GarrisonDoneFollowersFrame:Hide();
        GarrisonDoneFollowersScrollFrame:Hide();
        
        
    -- LOCK FRAME SIZE SETTINGS --
        
        GarrisonDoneFrame:SetMinResize(195,245);
        GarrisonDoneFrame:SetMaxResize(195,245);
        
        -- REGISTER EVENTS --
        -- Main frame --
        -- URGENT - Need to print this list and check which i need t keep and which i can loose --
        GarrisonDoneFrame:RegisterEvent("VARIABLES_LOADED")
        GarrisonDoneFrame:RegisterEvent("REGISTERFORDRAG")
        GarrisonDoneFrame:RegisterEvent("STORETEXT")
        GarrisonDoneFrame:RegisterEvent("ONTEXTCHANGED")
        GarrisonDoneFrame:RegisterEvent("UPDATE")
        GarrisonDoneFrame:RegisterEvent("GETTEXT")
        GarrisonDoneFrame:RegisterEvent("SETTEXT")
        GarrisonDoneFrame:RegisterEvent("ONSHOW")
        GarrisonDoneFrame:RegisterEvent("ONHIDE")
        GarrisonDoneFrame:RegisterEvent("ONCLICK")
        GarrisonDoneFrame:RegisterEvent("ZONE_CHANGED")
        GarrisonDoneFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
        GarrisonDoneFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
        GarrisonDoneFrame:RegisterEvent("GARRISON_UPDATE")
        GarrisonDoneFrame:RegisterEvent("CHAT_MSG_SYSTEM")
        GarrisonDoneFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
        GarrisonDoneFrame:RegisterEvent("LOOT_CLOSED")
        GarrisonDoneFrame:RegisterEvent("ADDON_LOADED")
        GarrisonDoneFrame:RegisterEvent("PLAYER_LOGIN")
        GarrisonDoneFrame:RegisterEvent("PLAYER_LOGOUT")
        GarrisonDoneFrame:RegisterEvent("GARRISON_FOLLOWER_ADDED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_FOLLOWER_REMOVED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_HIDE_LANDING_PAGE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_SHOW_LANDING_PAGE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_USE_PARTY_GARRISON_CHANGED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_FINISHED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_COMPLETE_RESPONSE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_LIST_UPDATE")
        GarrisonDoneFrame:RegisterEvent("TAXIMAP_OPENED")
        GarrisonDoneFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
        GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_ACTIVATED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_UPDATE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_REMOVED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDINGS_SWAPPED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_ACTIVATABLE")
	    GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_ERROR")
	    GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_LIST_UPDATE")
	    GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_PLACED")
	    GarrisonDoneFrame:RegisterEvent("GARRISON_BUILDING_UPDATE")
        GarrisonDoneFrame:RegisterEvent("SHIPMENT_CRAFTER_CLOSED")
	    GarrisonDoneFrame:RegisterEvent("SHIPMENT_CRAFTER_OPENED")
	    GarrisonDoneFrame:RegisterEvent("SHIPMENT_CRAFTER_REAGENT_UPDATE")
        GarrisonDoneFrame:RegisterEvent("SHOW_LOOT_TOAST")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_NPC_CLOSED")
        
        
	    table.insert(UISpecialFrames,"GarrisonDoneFrame");     
        
        -- SLASH COMMANDS --
        
        SlashCmdList["GARRISONDONE"] = function(sMsg)
			GarrisonDone_Slash_Command(sMsg)
		end
		SLASH_GARRISONDONE1 = "/mgd";
        SLASH_GARRISONDONE2 = "/gdone";
        
        GarrisonDone_Wait(30, GarrisonDone_Loaded(self, event))
end
 
-- C_Timer.After(30, function() GarrisonDone_Loaded(self, event, ...) end)           
    
        -- Set Default Variables --
function GarrisonDone_Loaded(self, event, ...)
        if (event == "VARIABLES_LOADED") then
        if GarrisonDone_Varsc == nil then
            GarrisonDone_Varsc = GarrisonDone_defaults
        end
        if GarrisonDone_Varsm == "nil" then
            GarrisonDone_Varsm = GarrisonDone_defaults
		end
        if not GarrisonDone_Varsc["version"] then
            GarrisonDone_Varsc["version"] = GarrisonDone_Version;
        end
        if not GarrisonDone_Vars[GetRealmName()] then
			GarrisonDone_Vars[GetRealmName()] = {}
		end
		if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] then
			GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
	    end
        if not GarrisonDone_Varsb[GetRealmName()] then
			GarrisonDone_Varsb[GetRealmName()] = {}
		end
		if not GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")] then
			GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")] = {}
	    end
        if not GarrisonDone_Varsf[GetRealmName()] then
			GarrisonDone_Varsf[GetRealmName()] = {}
		end
		if not GarrisonDone_Varsf[GetRealmName()][GetUnitName("player")] then
			GarrisonDone_Varsf[GetRealmName()][GetUnitName("player")] = {}
	    end
    end
end
   
   
        -- Load Variables and fire it up :) --
function GarrisonDone_OnEvent(self, event, ...)
        if event == "PLAYER_ENTERING_WORLD" then
            
        GarrisonDone_Varsc.version = GarrisonDone_Varsc.version;
		if GarrisonDone_Varsc.version == "nil" then
			GarrisonDone_Varsc.version = GarrisonDone_Version;
        elseif GarrisonDone_Varsc.version < GarrisonDone_Version then
            GarrisonDone_Varsc.version = GarrisonDone_Version;
		end
            -- Last Login to creat timer for reset --
        GarrisonDone_Varsc.lastLogin = GarrisonDone_Varsc.lastLogin;
		if GarrisonDone_Varsc.lastLogin == "nil" then
        GarrisonDone_Varsc.lastLogin = ""
        end
            -- Last Logout to creat timer for reset --
        GarrisonDone_Varsc.lastLogout = GarrisonDone_Varsc.lastLogout;
		if GarrisonDone_Varsc.lastLogout == "nil" then
        GarrisonDone_Varsc.lastLogout = ""
        end
            -- How many Nodes left to Mine --
        GarrisonDone_Varsc.miningLeft = tonumber(GarrisonDone_Varsc.miningLeft);
		if GarrisonDone_Varsc.miningLeft == "nil" then
			GarrisonDone_Varsc.miningLeft = ""
		end
            -- Max Mining based on Mine LvL --
        GarrisonDone_Varsc.maxMining = tonumber(GarrisonDone_Varsc.maxMining);
		if GarrisonDone_Varsc.maxMining == "nil" then
			GarrisonDone_Varsc.maxMining = ""
		end
            -- How many herbs still to pick --
        GarrisonDone_Varsc.herbingLeft = tonumber(GarrisonDone_Varsc.herbingLeft);
		if GarrisonDone_Varsc.herbingLeft == "nil" then
			GarrisonDone_Varsc.herbingLeft = ""
		end
            -- Max Herbing based on garden LvL --
        GarrisonDone_Varsc.maxHerbing = tonumber(GarrisonDone_Varsc.maxHerbing);
		if GarrisonDone_Varsc.maxHerbing == "nil" then
			GarrisonDone_Varsc.maxHerbing = ""
		end        
		    -- Here in case i need a refrence table --
		GarrisonDone_Varsc.reference = GarrisonDone_Varsc.reference;
		if GarrisonDone_Varsc.refrence == "nil" then
			GarrisonDone_Varsc.reference = ""
		end
            -- Do you have a Garrison --
        GarrisonDone_Varsc.hasGarrison = GarrisonDone_Varsc.hasGarrison;
		if GarrisonDone_Varsc.hasGarrison == "nil" then
			GarrisonDone_Varsc.hasGarrison = ""
		end
            -- Start/Stop Print Timer --
        GarrisonDone_Varsc.disptimer = GarrisonDone_Varsc.disptimer;
		if GarrisonDone_Varsc.disptimer == "nil" then
			GarrisonDone_Varsc.disptimer = ""
		end
            -- Hide /Show Variable for Auto Show --
        GarrisonDone_Varsc.auto = GarrisonDone_Varsc.auto;
		if GarrisonDone_Varsc.auto == "nil" then
		GarrisonDone_Varsc.auto = not(GarrisonDone_Varsc.auto)
        end
            -- Hide /Show Variable for Floating Button --        
        GarrisonDone_Varsc.button = GarrisonDone_Varsc.button; 
		if GarrisonDone_Varsc.button == "nil" then
		GarrisonDone_Varsc.button = not(GarrisonDone_Varsc.button)
        end 
            -- ON /OFF Variable for Audible Warning --        
        GarrisonDone_Varsc.warning = GarrisonDone_Varsc.warning; 
		if GarrisonDone_Varsc.warning == "nil" then
	    GarrisonDone_Varsc.warning = not(GarrisonDone_Varsc.warning)
		end
            -- ON /OFF Variable for Manual Frame Control --        
        GarrisonDone_Varsc.manual = GarrisonDone_Varsc.manual; 
		if GarrisonDone_Varsc.manual == "nil" then
	    GarrisonDone_Varsc.manual = not(GarrisonDone_Varsc.manual)
		end
            -- ON /OFF Variable for Login Timer Print Display--        
        GarrisonDone_Varsc.logintimer = GarrisonDone_Varsc.logintimer; 
		if GarrisonDone_Varsc.logintimer == "nil" then
	    GarrisonDone_Varsc.logintimer = not(GarrisonDone_Varsc.logintimer)
		end
            -- ON /OFF Variable for LDB Display to only Show Complete Missions --        
        GarrisonDone_Varsc.ldbcomp = GarrisonDone_Varsc.ldbcomp; 
		if GarrisonDone_Varsc.ldbcomp == "nil" then
	    GarrisonDone_Varsc.ldbcomp = not(GarrisonDone_Varsc.ldbcomp)
		end
            -- ON /OFF Variable for LDB Display to only Show Missions --        
        GarrisonDone_Varsc.ldbmiss = GarrisonDone_Varsc.ldbmiss; 
		if GarrisonDone_Varsc.ldbmiss == "nil" then
	    GarrisonDone_Varsc.ldbmiss = not(GarrisonDone_Varsc.ldbmiss)
		end
            -- Minimap Variables --
        GarrisonDone_Varsm.minimap = GarrisonDone_Varsm.minimap;
        if GarrisonDone_Varsm.minimap == "nil" then
            GarrisonDone_Varsm.minimap = {}
        end
            -- Minimap Variables Solution --
        GarrisonDone_Varsc.minimap = GarrisonDone_Varsc.minimap;
        if GarrisonDone_Varsc.minimap == "nil" then
            GarrisonDone_Varsc.minimap = {}
        end
    
        elseif (event=="GARRISON_MISSION_FINISHED") then
		    GarrisonDone_UpdateData()
	    elseif (event == "GARRISON_MISSION_COMPLETE_RESPONSE") then
		    GarrisonDone_Cleanup()
	    elseif (event == "GARRISON_MISSION_LIST_UPDATE") then
		    GarrisonDone_UpdateData()
    end
end	

    
        -- Check if player is lvl 90 --
function GarrisonDone_HasGarrison(self, event, ...)
        local level = UnitLevel("player")
        if event == "ADDON_LOADED" then
	    if level >= 90 and (IsQuestFlaggedCompleted(34586) or IsQuestFlaggedCompleted(34378)) then
		    GarrisonDone_Varsc.hasGarrison = true
        end
        elseif level < 90 then GarrisonDone_Varsc.hasGarrison = false
        GarrisonDone_ShutDown(self, ShutDown);
    end
end
  
        -- Not Level 90 or has not Unlocked Garrison --
function GarrisonDone_ShutDown(self, ShutDown)
        if GarrisonDone_Varsc.hasGarrison == false then        
        GarrisonDoneFrame:UnregisterEvent("VARIABLES_LOADED")
        GarrisonDoneFrame:UnregisterEvent("REGISTERFORDRAG")
        GarrisonDoneFrame:UnregisterEvent("STORETEXT")
        GarrisonDoneFrame:UnregisterEvent("ONTEXTCHANGED")
        GarrisonDoneFrame:UnregisterEvent("UPDATE")
        GarrisonDoneFrame:UnregisterEvent("GETTEXT")
        GarrisonDoneFrame:UnregisterEvent("SETTEXT")
        GarrisonDoneFrame:UnregisterEvent("ONSHOW")
        GarrisonDoneFrame:UnregisterEvent("ONHIDE")
        GarrisonDoneFrame:UnregisterEvent("ONCLICK")
        GarrisonDoneFrame:UnregisterEvent("ZONE_CHANGED")
        GarrisonDoneFrame:UnregisterEvent("ZONE_CHANGED_INDOORS")
        GarrisonDoneFrame:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("CHAT_MSG_SYSTEM")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
        GarrisonDoneFrame:UnregisterEvent("LOOT_CLOSED")
        GarrisonDoneFrame:UnregisterEvent("ADDON_LOADED")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_LOGIN")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_LOGOUT")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_FOLLOWER_ADDED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_FOLLOWER_REMOVED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_HIDE_LANDING_PAGE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_SHOW_LANDING_PAGE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_USE_PARTY_GARRISON_CHANGED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_MISSION_FINISHED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_MISSION_COMPLETE_RESPONSE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_MISSION_LIST_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("TAXIMAP_OPENED")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_LEAVING_WORLD")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_ACTIVATED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_REMOVED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDINGS_SWAPPED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_ACTIVATABLE")
	    GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_ERROR")
	    GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_LIST_UPDATE")
	    GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_PLACED")
	    GarrisonDoneFrame:UnregisterEvent("GARRISON_BUILDING_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("SHIPMENT_CRAFTER_CLOSED")
	    GarrisonDoneFrame:UnregisterEvent("SHIPMENT_CRAFTER_OPENED")
	    GarrisonDoneFrame:UnregisterEvent("SHIPMENT_CRAFTER_REAGENT_UPDATE")
	    GarrisonDoneFrame:UnregisterEvent("SHIPMENT_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("SHOW_LOOT_TOAST")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_MISSION_NPC_CLOSED")
        
--        MGD_Button:Hide();
        GarrisonDoneFrame:Hide();
        DisableAddOn("GarrisonDone");
        DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You do not have A Garrison, |cfffeef02Disabling Addon")
        else
        return
    end    
end

  
        -- Is Player in there Garrison, if yes auto Open --
function GarrisonDone_FrameAuto(self, event, ...)
        local playerName = UnitName("player");
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zoneName = GetSubZoneText();
        local zoneText = GetMinimapZoneText();
        
        if event == "ZONE_CHANGED" then
            
                -- Alliance --
			if (zoneText == (""..playerName.."'s Garrison") and GarrisonDone_Varsc.auto == true) or zoneText == "Town Hall" then
			GarrisonDoneFrame:Show();
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneEditFrame:Show();
            MGD_FollowersButton:Show();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            GarrisonDoneFollowersFrame:Hide();
            GarrisonDoneFollowersScrollFrame:Hide();
            elseif (mapname ~= "Lunarfall" or zoneText ~= (""..playerName.."'s Garrison") and GarrisonDone_Varsc.manual == false) then
			GarrisonDoneFrame:Hide();
            
                -- Horde --
			elseif (zoneText == (""..playerName.."'s Fort") and GarrisonDone_Varsc.auto == true) or zoneText == "Town Hall" then
			GarrisonDoneFrame:Show();
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneEditFrame:Show();
            MGD_FollowersButton:Show();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            GarrisonDoneFollowersFrame:Hide();
            GarrisonDoneFollowersScrollFrame:Hide();
            elseif (mapname ~= "Frostwall" or zoneText ~= (""..playerName.."'s Fort") and GarrisonDone_Varsc.manual == false) then
			GarrisonDoneFrame:Hide();
        end
    end
end
 
            -- No Misions in Progress Game Menu Warning --
function GarrisonDone_GameMenu(self, GameMenuFrame)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        if mip == 0 then
        if GameMenuFrame_UpdateVisibleButtons then
			hooksecurefunc("GameMenuFrame_UpdateVisibleButtons", function()
			GameMenuFrame:SetHeight(GameMenuFrame:GetHeight() + 25)
					end)
				end
			local point, relativeTo, relativePoint, x, y = GameMenuButtonQuit:GetPoint(1)
				if (relativeTo and relativeTo ~= self) then
					self:SetPoint(point, relativeTo, relativePoint, x, y)
			end
			GameMenuButtonQuit:ClearAllPoints()
		    GameMenuButtonQuit:SetPoint("TOP", self, "BOTTOM", 0, - 1)
    end
end

function GarrisonDone_GameMenuHide(self, GameMenuFrame)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        if mip ~= 0 then
        MGDGameMenu:Hide()
    end
end

            -- No Misions in Progress Flight Path Warning --
function GarrisonDone_WarningFp(self, event, ...)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
    if event == "TAXIMAP_OPENED" then
        if mip == 0 then
            GarrisonDoneFrame:Show();
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            PlaySound("RaidWarning", "Master")
        end
    end
end
              -- No Misions in Progress Zone Change Warning --        
function GarrisonDone_WarningZc(self, event, ...)     
    if event == "ZONE_CHANGED" then
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zone = GetCurrentMapZone();
        local zoneName = GetSubZoneText();
        local zoneText = GetMinimapZoneText();
        local faction = UnitFactionGroup("player")
          
                -- Alliance --
        if faction == "Alliance" then
	    if (zoneName == (""..playerName.."'s Garrison") or zoneText == (""..playerName.."'s Garrison")) then
            if mip == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
                end           
            end
        end
               -- Horde --
        elseif faction == "Horde" then
	    if (zoneName == (""..playerName.."'s Fort") or zoneText == (""..playerName.."'s Fort"))  then
        if mip == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
    --            end
            end
        end
    end
        elseif mip ~= 0 then 
            return
        end
    end
end
        
        
        -- No Misions in Progress Draenor Zone Warning --
function GarrisonDone_WarnZone(self, event, ...)
        if event == "ZONE_CHANGED_NEW_AREA" then
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zone = GetCurrentMapZone();
        local faction = UnitFactionGroup("player")
        
        if mip == 0 then
        if faction == "Alliance" then    
        if mapID == 947 then -- Shadowmoon Valley
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Garrison")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end        
        elseif mapID == 941 then -- Frostfire Ridge
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Highpass")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 949 then -- Gorgrond
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Highpass")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 946 then -- Talador
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Fort Wrynn")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 948 then -- Spires of Arak
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Southport")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 950 then -- Nagrand
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Telaari Station")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 978 then -- Ashran
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Garrison")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 945 then -- Tanaan Jungle
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933UnKnown")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        end
        
                                                    -- Find HORDE OUTPOSTS --
        elseif faction == "Horde" then
        if mapID == 947 then -- Shadowmoon Valley
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Axefall")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 941 then -- Frostfire Ridge
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 949 then -- Gorgrond
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Beast Watch")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 946 then -- Talador
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Vol'Jin's Pride")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 948 then -- Spires of Arak
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Axefall")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 950 then -- Nagrand
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Wor'Var")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 978 then -- Ashran
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 945 then -- Tanaan Jungle
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933UnKnown")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
                    end  
                end
            end
        end
    end
end
   
            
            
            -- Open on Mission Window Close --
function GarrisonDone_MissionFrame(self, event, ...)
        if event == "GARRISON_MISSION_NPC_CLOSED" then
            GarrisonDoneFrame:Show();
            GarrisonDoneEditFrame:Show();
            MGD_FollowersButton:Show();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            GarrisonDoneFollowersFrame:Hide();
            GarrisonDoneFollowersScrollFrame:Hide();
    end
end

  
            
           -- Delay Counter for Spell Casts -- 
C_Timer.After(20, function() GarrisonDone_CounterEvents(self, elapsed) end)


   
        -- BEGIN COUNT DOWN HERBS AND ORE --   
function GarrisonDone_CounterEvents(self, elapsed)
        GarrisonDoneFrame:RegisterEvent("UNIT_SPELLCAST_START")
        GarrisonDoneFrame:RegisterEvent("UNIT_SPELLCAST_STOP")
        GarrisonDoneFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end
            
         -- Count Ore --
function GarrisonDone_CountOre(self, event, ...)
        if event == "UNIT_SPELLCAST_START" then
        local unit, spell = ...
		if (unit == "player" and spell == "Mining") then
            return
        end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local unit, spell = ...
		if (unit == "player" and spell == "Mining") then
            GarrisonDone_OreCounter(self, GarrisonDone_CountOre);
            end
        end
        if event == "UNIT_SPELLCAST_START" then
            local unit, spell = ...
		if ((spell == "Herbalism" or spell == "Herb Gathering") and unit == "player") then
            return
        end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local unit, spell = ...
		if ((spell == "Herbalism" or spell == "Herb Gathering") and unit == "player") then
            GarrisonDone_HerbCount(self, GarrisonDone_CountHerbs);
        end
    end
end
            -- Now actually do the ore counter --
function GarrisonDone_OreCounter(self, GarrisonDone_CountOre)
        local zoneText = GetMinimapZoneText();
		local zoneName = GetSubZoneText();
		if (zoneName == "Lunarfall Excavation" or zoneName == "Frostwall Mine") or (zoneText == "Lunarfall Excavation" or zoneText == "Frostwall Mine") then
			GarrisonDone_Varsc.miningLeft = GarrisonDone_Varsc.miningLeft - 1;
            GarrisonDone_Update(self);
        DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20Were Mining") -- Debug --
    end
end
        
            -- Now actually do the herb counter --
function GarrisonDone_HerbCount(self, GarrisonDone_CountHerbs)
        local playerName = UnitName("player");
        local zoneText = GetMinimapZoneText();
		local zoneName = GetSubZoneText();
		if zoneText == (""..playerName.."'s Garrison") or zoneText == (""..playerName.."'s Fort") then  -- would still like this to be the garden --
			GarrisonDone_Varsc.herbingLeft = GarrisonDone_Varsc.herbingLeft - 1;
            GarrisonDone_Update(self);
        DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20Were Herbing") -- Debug --
    end
end
            -- Un Register Count Events when were done --
function GarrisonDone_CountComplete(self)
    if (GarrisonDone_Varsc.herbingLeft == 0 and GarrisonDone_Varsc.miningLeft == 0)  then
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_START")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_STOP")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    end
end
        -- END ORE AND HERB COUNT SYSTEM --
        



        -- Set Old times based on logout so reset works --
function GarrisonDone_OnLogout(self, event, ...)        
    if event == "PLAYER_LOGOUT" then
        GarrisonDone_Varsc.lastLogout = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
		}
    end
end
    
     
   
        -- SHOW FRAMES and Update --    
function GarrisonDone_OnShow(self)
    GarrisonDoneFrame:Show();
    PanelTemplates_SetTab(GarrisonDoneFrame, 1);
    if GarrisonDoneEditFrame:Show() == true then
        GarrisonDone_Update(self);
        MGD_FollowersButton:Show();
        GarrisonDoneBuildFrame:Hide();
        GarrisonDoneBuildScrollFrame:Hide();
        GarrisonDoneAltsFrame:Hide();
        GarrisonDoneAltsScrollFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
        GarrisonDoneFollowersFrame:Hide();
        GarrisonDoneFollowersScrollFrame:Hide();
    end
end  



 
        -- TOGGLES FRAME USEING SLASH COMMAND --
function GarrisonDone_Slash_Command(sMsg)
	if GarrisonDoneFrame:IsVisible() then
		GarrisonDoneFrame:Hide();
	else
		GarrisonDoneFrame:Show();
        GarrisonDoneEditFrame:Show();
        MGD_FollowersButton:Show();
        GarrisonDoneBuildFrame:Hide();
        GarrisonDoneBuildScrollFrame:Hide();
        GarrisonDoneAltsFrame:Hide();
        GarrisonDoneAltsScrollFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
        GarrisonDoneFollowersFrame:Hide();
        GarrisonDoneFollowersScrollFrame:Hide();
	end
end
  
        -- MOVES FRAME --
function GarrisonDone_OnMouseDown(self)
    if (IsShiftKeyDown() and Button == "Shift-RightButton") then
	    GarrisonDoneFrame:StartMoving();
    end
end
  
function GarrisonDone_OnMouseUp(self)
	if (IsShiftKeyDown() and Button == "Shift-RightButton") then
	GarrisonDoneFrame:StopMovingOrSizing();
	end
end
 
 
        -- FLOATING BUTTON --
function GarrisonDone_ShowMini(self, event, ...)
    if event == "PLAYER_ENTERING_WORLD" then
	if (GarrisonDone_Varsc.button == true) then
        MGDButton:Show();
        end
    elseif (GarrisonDone_Varsc.button ~= true) then
        MGDButton:Hide();
    end
end


        -- MGD Button Tooltip --
function MGDButton_OnEnter(MGDButton)
    GameTooltip:SetOwner(MGDButton, "ANCHOR_BOTTOMLEFT")
    GameTooltip:SetText("My Garrison is Done")
    GameTooltip:AddLine("Left Click to Open My Garrison", 1, 1, 1)
    GameTooltip:AddLine("Shift Right Click to Move", 1, 1, 1)
    GameTooltip:AddLine("Shift Right Click to Save Position", 1, 1, 1)
    GameTooltip:Show();
end

function MGDButton_OnLeave(MGDButton)
    GameTooltip:Hide()
end

      

        -- REMOVES FRAME IF DISABLE TRUE --
function GarrisonDone_MakeESCable(frame,disable)
	local idx
	for i=1,#(UISpecialFrames) do
		if UISpecialFrames[i]==frame then
			idx = i
			break
		end
	end
	if idx and disable then
		table.remove(UISpecialFrames,idx)
	elseif not idx and not disable then
		table.insert(UISpecialFrames,1,frame)
	end
end



 

        -- CURRENT PLAYER FRAME STARTS HERE --

function GarrisonDone_Update(self)
    -- Assign Local Variables straight from Blizz frame --
    
    
    -- Max Followers --
    local maxFollowers = C_Garrison.GetFollowerSoftCap(LE_FOLLOWER_TYPE_GARRISON_6_0);
    local maxShips = C_Garrison.GetFollowerSoftCap(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
    -- Active Followers --
    local numActiveFollowers = C_Garrison.GetNumActiveFollowers(LE_FOLLOWER_TYPE_GARRISON_6_0);
    local numActiveShips = C_Garrison.GetNumActiveFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
    -- Missions Available --
    local AvailableItems = C_Garrison.GetAvailableMissions();
    local shipMissions = 0
    
    -- Missions Complete --
    local completeMissions = C_Garrison.GetCompleteMissions();
    local shipComplete = 0
    
    
    -- Missions in Progress --
    local items = C_Garrison.GetLandingPageItems();  
    local mip = #items - #completeMissions;
    -- Ship Missions in Progress --
    local sitems = 0
    local smips = sitems - shipComplete

    -- Mining Nodes --
    local ore = 0;
    if GarrisonDone_Varsc.hasMine == true then
		if GarrisonDone_Varsc.miningLeft > 0 then
		ore = format("%s", GarrisonDone_Varsc.miningLeft)
            tonumber(ore)
		end
    end
    local ores = 0;
    if GarrisonDone_Varsc.hasMine == true then
		if GarrisonDone_Varsc.maxMining > 0 then
		ores = format("%s", GarrisonDone_Varsc.maxMining)
            tonumber(ores)
		end
	end 
    
    
    -- Herb Nodes --
    local herb = 0;
    if GarrisonDone_Varsc.hasGarden == true then
    	if GarrisonDone_Varsc.herbingLeft > 0 then
		herb = format("%s", GarrisonDone_Varsc.herbingLeft)
            tonumber(herb)
		end
	end 
    local herbs = 0;
    if GarrisonDone_Varsc.hasGarden == true then
		if GarrisonDone_Varsc.maxHerbing > 0 then
		herbs = format("%s", GarrisonDone_Varsc.maxHerbing)
            tonumber(herbs)
		end
	end
    
    
        -- Find all our Followers and Set Status --
    local followers = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_GARRISON_6_0);
    
    -- Followers working --
    local work = 0;
    for i = 1, #followers do
	if ( followers[i].status == GARRISON_FOLLOWER_WORKING) then
		work = work + 1;
        end
    end
    -- Followers on Missions --
    local gfm = 0;
    for i = 1, #followers do
	if ( followers[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		gfm = gfm + 1;
        end
    end
       
    local fBusy = gfm + work;
    local available = numActiveFollowers - fBusy;
    
    local atSea = 0;
    local harbour = numActiveShips - atSea;

        -- Garrison Resources --
    local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);
    local _, currAmount, _, _, _, _, _ = GetCurrencyInfo(1101);
    
	-- Set Contents Main Frame --
	if (GarrisonDoneEditFrame:IsShown()) then
        -- Players Garrison --
		GarrisonDonePageName:SetText(""..playerName.."'s  Garrison");
        -- Max Followers --
		MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers.."");
            if numActiveFollowers == 30 then
        MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r|cff00aa00"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers..""); 
            elseif numActiveFollowers > 30 then
        MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r|cffff0000"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers..""); 
            end
        -- Missions in Progress --
            if mip ~= 0 then
		MGDFMPageName:SetText("Missions in Progress|cff007fff = |cffffffff"..mip.."");
            elseif mip == 0 then
        MGDFMPageName:SetText("|cffffffffMissions in Progress|cff007fff = |r|cffff0000"..mip.."");
            end
        -- Complete Missions --
		MGDMCPageName:SetText("Missions Complete|cff007fff = |cff00aa00"..#completeMissions.."");
        -- Missions Available --
		MGDMAPageName:SetText("Missions Available|cff007fff = |r"..#AvailableItems.."");
        -- Followers Available --
		MGDFAPageName:SetText("|cff62fb71Followers Available|cff007fff = |r"..available.."");
            if available == 0 then
        MGDFAPageName:SetText("|cff62fb71Followers Available|cff007fff = |r|cff00aa00"..available.."");
            elseif available > 25 then
        MGDFAPageName:SetText("|cff62fb71Followers Available|cff007fff = |r|cffff0000"..available.."");       
            end
        -- Followers Working
		MGDFWPageName:SetText("|cff62fb71Followers Working|cff007fff = |r"..work.."");
        -- Followers on Mission
	    MGDFOMPageName:SetText("|cff62fb71Out On A Mission|cff007fff = |cffFF8000"..gfm.."");
            if gfm == 0 then
        MGDFOMPageName:SetText("|cff62fb71Followers on Mission|cff007fff = |cffff0000"..gfm.."");
            end
        -- Ships Missions Complete --
        SMCPageName:SetText("Ships Completed|cff007fff = |r"..shipComplete.."/|cffffffff"..smips.."");
        -- Ships Mission Available --
        SMAPageName:SetText("Ship Missions Avail|cff007fff =|r "..shipMissions..""); 
        -- Number of Ships --
        NMSPageName:SetText("|cff53aafcTotal Ships|cff007fff = |r|cff00aa00"..numActiveShips.."/|cffFF8000"..maxShips.."")
        -- Ships out on Mission --
        MSSPageName:SetText("|cff53aafcShips at Sea|cff007fff = |r"..atSea.."")
        -- Ships in Shipyard --
        SSSPageName:SetText("|cff53aafcShips in Harbour|cff007fff = |r|cff00aa00"..numActiveShips.."")
        -- Mining Nodes --
            if ore ~= 0 and herb ~= 0 then
		MGDMNPageName:SetText("Mine|cff007fff:|cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs|cff007fff:|cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
            elseif ore == 0 and herb ~= 0 then
        MGDMNPageName:SetText("Mine|cff007fff:|r"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs|cff007fff:|cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
            end
        -- Herb Nodes --
            if herb ~= 0  and ore == 0 then
		MGDMNPageName:SetText("Mine|cff007fff:|r"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs|cff007fff:|cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
            elseif herb == 0 and ore == 0 then
        MGDMNPageName:SetText("Mine|cff007fff:|r"..ore.."|cff007fff/|cff00aa00"..ores.."|r Herbs|cff007fff:|r"..herb.."|cff007fff/|cff00aa00"..herbs.."");  
            end
        -- Garrison Resources --
		MGDGRPageName:SetText("Resources|cff007fff = |r"..currentAmount.."/|cffFF8000"..currAmount.."")
        -- Reset Game Menu without reload --
        GarrisonDone_GameMenuHide(self, GameMenuFrame);
    end
end

     
       
        -- OPTIONS TAB FRAME STARTS HERE --
        
        -- Open Options Frame --
function GarrisonDoneOpt_Open()        
        if GarrisonDoneOptEditFrame:IsShown() then
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneFrame:Show();
			GarrisonDoneEditFrame:Show();
            MGD_FollowersButton:Show();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            GarrisonDoneFollowersFrame:Hide();
            GarrisonDoneFollowersScrollFrame:Hide();
        else
            GarrisonDoneOptEditFrame:Show();
            GarrisonDoneEditFrame:Hide();
            MGD_FollowersButton:Hide();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDoneFollowersFrame:Hide();
            GarrisonDoneFollowersScrollFrame:Hide();
            GarrisonDone_OptionsOnShow(self);
    end
end

    -- MGD Options Tooltip --
function MGD_OptsButton_OnEnter(MGD_OptsButton)
    GameTooltip:SetOwner(MGD_OptsButton, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Options")
    GameTooltip:AddLine("Opens the Options Frame.", 1, 1, 1)
    GameTooltip:Show();
end
          
        -- Auto Open Variable --
function GarrisonDone_Auto(self, MGD_Auto)
        local state = MGD_Auto:GetChecked()
	    if state then
		GarrisonDone_Varsc.auto = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto open is now ON");
        else
        GarrisonDone_Varsc.auto = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto Open is now OFF");
	end
end
        -- MGD Auto Open Tooltip --
function MGD_Auto_OnEnter(MGD_Auto)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Auto Opening")
    GameTooltip:AddLine("Toggles the Auto Open Function in Your Garrison.", 1, 1, 1)
    GameTooltip:AddLine("Will still Auto Open on Entering Town Hall", 1, 1, 1)
    GameTooltip:Show();
end


        -- Audio Warning Variable --
function GarrisonDone_Warn(self, MGD_Warn)
        local state = MGD_Warn:GetChecked()
	    if state then
		GarrisonDone_Varsc.warning = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Warning Sound is now ON");
        else
        GarrisonDone_Varsc.warning = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Warning Sound is now OFF");
	end
end      
        -- MGD Audio Warning Tooltip --
function MGD_Warn_OnEnter(MGD_Warn)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Audio Raid Warning")
    GameTooltip:AddLine("Toggles the Raid Warning Function.", 1, 1, 1)
    GameTooltip:AddLine("Will still operate on Flight Path Open", 1, 1, 1)
    GameTooltip:Show();
end


        -- Mini Button Variable --     
function GarrisonDone_MiniButton(self, MGD_Mini)
        local state = MGD_Mini:GetChecked()
	    if state then
		GarrisonDone_Varsc.button = true;
        MGDButton:Show()
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Button is now ON");
	    else
		GarrisonDone_Varsc.button = false;
        MGDButton:Hide()
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Button is now OFF"); 
	end
end
        -- MGD Floating Button Tooltip --
function MGD_Mini_OnEnter(MGD_Mini)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Floating Button")
    GameTooltip:AddLine("Toggles the Garriosn Done floating Button", 1, 1, 1)
    GameTooltip:Show();
end


        -- Manual Window Control --
function GarrisonDone_Manual(self, MGD_Manual)
        local state = MGD_Manual:GetChecked()
	    if state then
		GarrisonDone_Varsc.manual = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Manual Window Control is ON");
	    else
		GarrisonDone_Varsc.manual = false;
    
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Manual Window Control is OFF"); 
	end
end
        -- Manual Window Control Tooltip --
function MGD_Manual_OnEnter(MGD_Manual)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Manual Window Control")
    GameTooltip:AddLine("Turns Off Auto Close", 1, 1, 1)
    GameTooltip:Show();
end

-- Display Timer Variable --
function GarrisonDone_ChatTimer(self, MGD_Cdt)
        local state = MGD_Cdt:GetChecked()
	    if state then
		GarrisonDone_Varsc.disptimer = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Chat Display Timer is ON");
	    else
		GarrisonDone_Varsc.disptimer = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Chat Display Timer is OFF"); 
	end
end
        -- MGD Display Timer Tooltip --
function MGD_Cdt_OnEnter(MGD_Cdt)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Chat Frame Display")
    GameTooltip:AddLine("Toggle 30 min Timer", 1, 1, 1)
    GameTooltip:AddLine("Timer lasts 5 hours.", 1, 1, 1)
    GameTooltip:AddLine("Certain Events will", 1, 1, 1)
    GameTooltip:AddLine("Restart the Timer.", 1, 1, 1)
    GameTooltip:Show();
end

        -- Display Login Timer Variable --
function GarrisonDone_LoginTimer(self, MGD_Lgt)
        local state = MGD_Lgt:GetChecked()
	    if state then
		GarrisonDone_Varsc.logintimer = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Login Print Display is ON");
	    else
		GarrisonDone_Varsc.logintimer = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Login Print Display is OFF"); 
	end
end
        -- MGD Login Timer Tooltip --
function MGD_Lgt_OnEnter(MGD_Lgt)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Login Chat Display")
    GameTooltip:AddLine("Toggle ON/OFF", 1, 1, 1)
    GameTooltip:Show();
end

        -- Display LDB Complete only Variable --
function GarrisonDone_LDBComp(self, MGD_Ldbc)
        local state = MGD_Ldbc:GetChecked()
	    if state then
		GarrisonDone_Varsc.ldbcomp = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff LDB will Only Show Completed Missions");
	    else
		GarrisonDone_Varsc.ldbcomp = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff LDB will Display All Misisons"); 
	end
end
        -- MGD LDB Complete Only Tooltip --
function MGD_Ldbc_OnEnter(MGD_Ldbc)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("LDB Completed Display")
    GameTooltip:AddLine("Toggle ON/OFF", 1, 1, 1)
    GameTooltip:AddLine("Change LDB to Only Display", 1, 1, 1)
    GameTooltip:AddLine("Completed Missions", 1, 1, 1)
    GameTooltip:Show();
end


         -- Display LDB Missions only Variable --
function GarrisonDone_LDBMiss(self, MGD_Ldbm)
        local state = MGD_Ldbm:GetChecked()
	    if state then
		GarrisonDone_Varsc.ldbmiss = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff LDB will Only Show Missions");
	    else
		GarrisonDone_Varsc.ldbmiss = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff LDB will Display All Data"); 
	end
end
        -- MGD LDB Complete Only Tooltip --
function MGD_Ldbm_OnEnter(MGD_Ldbm)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("LDB Missions Display")
    GameTooltip:AddLine("Toggle ON/OFF", 1, 1, 1)
    GameTooltip:AddLine("Change LDB to Missions Only", 1, 1, 1)
    GameTooltip:Show();
end
  

-- Hide Minimap variable --       
function GarrisonDone_Map(self, MGD_Map)
        local state = MGD_Map:GetChecked()
	    if state then
            GarrisonDone_Varsm.minimap.hide = true;
            GarrisonDone_Varsc.minimap = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Hide Minimap Icon, will take effect on next reload");
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff This Will Hide on All Characters");
	    else  
            GarrisonDone_Varsm.minimap.hide = false;
            GarrisonDone_Varsc.minimap = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Show Minimap Icon, will take effect on next reload");
	end
end


        -- MGD Hide Minimap Tooltip --
function MGD_Map_OnEnter(MGD_Map)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Mini Map Icon")
    GameTooltip:AddLine("Hides the Minimap Icon", 1, 1, 1)
    GameTooltip:AddLine("Hides on All Characters.", 1, 1, 1)
    GameTooltip:Show();
end


 
        -- Set Options Frame --
function GarrisonDone_OptionsOnShow(self)   
        if (GarrisonDoneOptEditFrame:IsShown()) then
        -- Alts Garrisons --
		GarrisonDoneOptPageName:SetText("Options Panel");
        -- Missions Complete and in Progress --  
		MGDOptCPageName:SetText("|cffFF8000Verison - |cff00aa00"..GarrisonDone_Version.."");
        MGD_Auto:SetChecked(GarrisonDone_Varsc.auto)
        MGD_Warn:SetChecked(GarrisonDone_Varsc.warning)
        MGD_Mini:SetChecked(GarrisonDone_Varsc.button)
        MGD_Manual:SetChecked(GarrisonDone_Varsc.manual)
        MGD_Cdt:SetChecked(GarrisonDone_Varsc.disptimer)
        MGD_Lgt:SetChecked(GarrisonDone_Varsc.logintimer)
        MGD_Ldbc:SetChecked(GarrisonDone_Varsc.ldbcomp)
        MGD_Ldbm:SetChecked(GarrisonDone_Varsc.ldbmiss)
        MGD_Map:SetChecked(GarrisonDone_Varsm.minimap.hide)
    end
end


        -- OTHER TOOLTIPS --
        
    -- Buildings Frame Tooltip --
function GarrisonDoneBuildScrollFrame_OnEnter(GarrisonDoneBuildScrollFrame)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT", 0 ,5)
    GameTooltip:SetText("Your Buildings")
    GameTooltip:AddLine("What the Numbers Mean.", 1, 1, 1)
    GameTooltip:AddLine("|cff1eff00Ready Now.", 1, 1, 1)
    GameTooltip:AddLine("|cfffeef02In Progress.", 1, 1, 1)
    GameTooltip:AddLine("|cffe6cc80Total Capacity.", 1, 1, 1)
    GameTooltip:AddLine("|cffe6cc80-------------------", 1, 1, 1)
    GameTooltip:AddLine("|cfffeef02Out to Lunch Means.", 1, 1, 1)
    GameTooltip:AddLine("|cffff0000Not Doing Anything!", 1, 1, 1)
    GameTooltip:Show();
end

function GarrisonDoneBuildScrollFrame_OnLeave(self)
    GameTooltip:Hide()
end

    -- Buildings and Shipments Tab Tooltip --
function GarrisonDoneFrameTab2_OnEnter(self)
    GameTooltip:SetOwner(GarrisonDoneFrameTab2, "ANCHOR_BOTTOMLEFT")
    GameTooltip:SetText("Buildings and Shipments")
    GameTooltip:Show();
end

function GarrisonDoneFrameTab2_OnLeave(self)
    GameTooltip:Hide()
end


    -- Buildings and Shipments Tab Tooltip --
function GarrisonDoneFrameTab3_OnEnter(self)
    GameTooltip:SetOwner(GarrisonDoneFrameTab3, "ANCHOR_BOTTOMRIGHT")
    GameTooltip:SetText("All Missions")
    GameTooltip:Show();
end

function GarrisonDoneFrameTab3_OnLeave(self)
    GameTooltip:Hide()
end

    -- Garriosn Resources and Oil --
function MGD_Fake1Button_OnEnter(self)
    GameTooltip:SetOwner(MGD_Fake1Button, "ANCHOR_BOTTOMRIGHT")
    GameTooltip:SetText("All Resources")
    GameTooltip:AddLine("Garrison / |cffFF8000Oil")
    GameTooltip:Show();
end

function MGD_Fake1Button_OnLeave(self)
    GameTooltip:Hide()
end

